/* TRS-80 compatability functions */
#if !defined(TRS80_H)
#define TRS80_H
#include <bios.h>
#include <conio.h>
#include <ctype.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define HORZOFF     8
#define VERTOFF     4

#define PrintAt(x)  poscurs(VERTOFF+(x)/64, HORZOFF+(x)%64)

float   timefactor;

void    InitializeTRS80(int);
char    Inkey$(void);
void    Random(void);
double  Rnd(int);
void    Cls();
void    ForLoop(float);
void    PrintTab(int);
char    Look(int);

char    Look(int p) {
  int  oldrow, oldcol;
  char c;

  oldrow = cursrow();
  oldcol = curscol();
  PrintAt(p);
  c = readch();
  poscurs(oldrow, oldcol);
  return c;
} /* Look */

void    PrintTab(int x) {
        union REGS r;

        if (cursrow()<(VERTOFF+0x10)) {
          poscurs(cursrow(), HORZOFF+x);
        } else {
          r.h.ah = 0x06;
          r.h.al = 0x01;
          r.h.bh = 0x17; /* attribute */
          r.h.ch = VERTOFF;
          r.h.cl = HORZOFF;
          r.h.dh = VERTOFF+0x10-1;
          r.h.dl = HORZOFF+0x40-1;
          int86(0x10, &r, &r);
          poscurs(cursrow()-1, HORZOFF+x);
        }
}

char    Inkey$(void) {
        char c;
        c = tolower((char)(bioskey(1)&0xff));
        if (c)
          bioskey(0);
        return c;
} /* Inkey$ */

void    Cls(void) {
        union REGS r;

        clrscrn2(0x17);

        r.h.ah = 0x06;
        r.h.al = 0x00;
        r.h.bh = 0x07; /* attribute */
        r.h.ch = VERTOFF;
        r.h.cl = HORZOFF;
        r.h.dh = VERTOFF+0x10-1;
        r.h.dl = HORZOFF+0x40-1;
        int86(0x10, &r, &r);

        poscurs(VERTOFF, HORZOFF);
        return;
} /* Cls */

void    InitializeTRS80(int mode) {
        time_t current, start;
    
        for (time(&start),time(&current),timefactor=0;
             difftime(current, start)!=2.0;
             time(&current)) timefactor++;
        if (kbhit()) getch();
        timefactor /= 2;
} /* InitializeTRS80 */

void    Random(void) {
        time_t current;

        srand(current);
        return;
} /* Random */

double  Rnd(int n) {
        if (n)
            return (double)(rand()%n);
        else
            return (double)rand()/RAND_MAX;
} /* Rnd */

void    ForLoop(float delay) {
        int   keystatus;
        unsigned long d, t=0;
        time_t current;
        char  c = 0;

        d = delay*timefactor/1000;
        for (t=0; t<d; t++) {
          time(&current);
          difftime(&current, &current);
        }
        return;
} /* ForLoop */
#endif
